Menu menu;
float state = 0;
float unitW;
float unitH;
import processing.serial.*;
import cc.arduino.*;
Arduino potOne;


// BUTTON CLASSES
SuperButton[] button;

LoadPlant loadplant;
CreateNew createnew;
PlantType type1;
PlantType type2;
PlantType type3;
PlantType type4;
PlantType type5;
PlantType type6;
LoadFile loadfile;
PlantName plantname;
PlantAge plantage1;
PlantAge plantage2;
PlantAge plantage3;
PlantAge plantage4;
NACheck nacheck;

// CONTROLLER
Controller controller = new Controller(0, 1);

void setup() {
  menu = new Menu(); 
  fullScreen();
  unitW = width/19.2;
  unitH = height/10.8;

  loadplant = new LoadPlant(2.5*unitW, 5.6*unitH, 4*unitW, 4*unitH, 1);
  createnew = new CreateNew(2.5*unitW, .9*unitH, 4*unitW, 4*unitH, 1);

  type1 = new PlantType(2.5*unitW, .9*unitH, 4*unitW, 4*unitH, 1);
  type2 = new PlantType(8*unitW, .9*unitH, 4*unitW, 4*unitH, 2);
  type3 = new PlantType(13.5*unitW, .9*unitH, 4*unitW, 4*unitH, 3);
  type4 = new PlantType(2.5*unitW, 5.6*unitH, 4*unitW, 4*unitH, 4);
  type5 = new PlantType(8*unitW, 5.6*unitH, 4*unitW, 4*unitH, 5);
  type6 = new PlantType(13.59*unitW, 5.6*unitH, 4*unitW, 4*unitH, 6);

  loadfile = new LoadFile(2.5*unitW, .9*unitH, 4*unitW, 4*unitH, 1);

  plantname = new PlantName(2.5*unitW, .9*unitH, 4*unitW, 4*unitH, 1);
  plantage1 = new PlantAge(3*unitW, 2.75*unitH, unitW/3, unitH/3, 1);
  plantage2 = new PlantAge(3.6*unitW, 2.75*unitH, unitW/3, unitH/3, 2);
  plantage3 = new PlantAge(5.1*unitW, 2.75*unitH, unitW/3, unitH/3, 3);
  plantage4 = new PlantAge(5.7*unitW, 2.75*unitH, unitW/3, unitH/3, 4);
  nacheck = new NACheck(3.5*unitW, 3.9*unitH, 2*unitW, unitH/2, 1);

  button = new SuperButton[15];

  button[0] = loadplant;
  button[1] = createnew;
  button[2] = type1;
  button[3] = type2;
  button[4] = type3;
  button[5] = type4;
  button[6] = type5;
  button[7] = type6;
  button[8] = loadfile;
  button[9] = plantname;
  button[10] = plantage1;
  button[11] = plantage2;
  button[12] = plantage3;
  button[13] = plantage4;
  button[14] = nacheck;

  for (int i = 0; i < keys.length; i++) {
    if (i < 10) {
      keys[i] = new KeyBoard(i*1.2*unitW + 4*unitW, 5.4*unitH, unitW, unitH, i);
    } else if (i < 19) {
      keys[i] = new KeyBoard((i-10)*1.2*unitW + 4.6*unitW, 6.6*unitH, unitW, unitH, i);
    } else if (i < 28) {
      keys[i] = new KeyBoard((i-19)*1.2*unitW + 5.2*unitW, 7.8*unitH, unitW, unitH, i);
    } else if (i == 28) {
      keys[i] = new KeyBoard(15.4*unitW, 6.6*unitH, unitW*2, unitH, i);
    } else if (i == 29) {
      keys[i] = new KeyBoard(4*unitW, 7.8*unitH, unitW, unitH, i);
    } else if (i == 30) {
      keys[i] = new KeyBoard(5.5*unitW, 9*unitH, 8*unitW, unitH, i);
    } else {
      keys[i] = new KeyBoard(0, 0, unitW, unitH, i);
    }
  }
  println(Arduino.list());
  potOne = new Arduino(this, Arduino.list()[0], 57600);
}

void draw() {
  menu.display();
  controller.run();
}

void mousePressed() {
  menu.checkHitbox(mouseX, mouseY);
  controller.checkHitbox(mouseX, mouseY);
}

void keyPressed() {
  //to check if the diagram and savedata works
  if (key==ENTER) {
    menu.saveData(true);
  }
  // println(key);
  if (keyCode==SHIFT) {
  } else if (keyCode == BACKSPACE) {
    controller.textdelete();
  } else {
    controller.textinput(str(key));
  }
}
