class Menu {
  Education education;
  ArrayList<Plant> plants;
  PImage bar;
  PImage waterBar, sunBar, eduBar, home;
  PImage basefact, basestatus;
  int w = width;  //3840
  int h = height; //2160
  Table td;
  int saveTime;
  int readTime;
  

  Menu() {
    education = new Education();
    plants = new ArrayList<Plant>();
    bar = loadImage("navigationBar.jpg");
    waterBar = loadImage("navigationBarWater.jpg");
    sunBar = loadImage("navigationBarSun.jpg");
    eduBar = loadImage("navigationBarEdu.jpg");
    home = loadImage("navigationBarHome.jpg");
    basefact = loadImage("FunFact.jpg");       // base for the facts; basic lay-out
    basestatus = loadImage("plantStatus.jpg"); // base for the status of a plant; basic lay-out
    td = loadTable("plantTable.csv", "header");
    //chechks if there is a table, if not will go to catch and makes a new table
    try {
      println(td.getRowCount());
    }
    catch(Exception NullPointerException) {
      td = new Table();
      td.addColumn("type", Table.STRING);
      td.addColumn("name", Table.STRING);
      td.addColumn("age", Table.INT);
      saveTable(td, "plantTable.csv");
    }
    //load the plants from the table
    loadPlant();
  }

  void display() {
    //function has a boolean to check whether it works or not, by pressing ENTER you can savedata yourselves
    saveData(false);
    readData();
    background(255);
    noStroke();
    rectMode(CORNER);
    fill(242);
    rect(w/100+w/14.12, w/100, w/1.11, h/1.05);
    imageMode(CORNER);
    if (state == 0) {
      image(basestatus, w/1.4, h/21, w/4, h/1.92);
      //rectMode(CENTER);
      //fill(255);
      //rect(w/1.26, h/5.17, w/8, h/20);
      //textAlign(CENTER, CENTER);
      //if(plants.size()>=0){
      //  Plant p = plants.get(0);
      //  fill(0);
      //text(p.name, w/1.26, h/5.17);
      //rectMode(CORNER);
      //}
      image(basefact, w/1.4, h/1.7, w/4, h/2.74);
      image(bar, w/70, w/100, w/15, h-h/20);    //selected home screen menu
      image(home, w/100, w/100, w/14.12, h/1.99);
    } else if (state == 1) {
      image(eduBar, w/100, w/100, w/14.12, h/1.99);   //selected education menu
      education.display();
      for (int i = 0; i<plants.size(); i++) {
        Plant p = plants.get(i);
        p.show();
      }
    } else if (state == 2) {
      image(sunBar, w/100, w/100, w/14.12, h/1.99);   //selected sun graphs menu
      for (int i = 0; i<plants.size(); i++) {
        Plant p = plants.get(i);
        p.updateTime();
        p.showSunGraph();
      }
    } else if (state == 3) {
      image(waterBar, w/100, w/100, w/14.12, h/1.99);  //selected water graphs menu
      for (int i = 0; i<plants.size(); i++) {
        Plant p = plants.get(i);
        p.updateTime();
        p.showWaterGraph();
      }
    } else if (state == 4) {
      image(eduBar, w/100, w/100, w/14.12, h/1.99);
      education.Article();
    } else if (state == 5) {
      image(eduBar, w/100, w/100, w/14.12, h/1.99);
      education.Movie();
    } else if (state == 6) {
      image(eduBar, w/100, w/100, w/14.12, h/1.99);
      education.AgriArt();
    } else if (state == 7) {
      image(eduBar, w/100, w/100, w/14.12, h/1.99);
      education.AgriMov();
    }
  }

  void newPlant(String pName, int pAge, String pType) {
    if (plants.size()<3) {
      Plant p = new Plant(pName, pType, td.getRowCount(), pAge);
      plants.add(p);
      td.addRow();
      td.setString(td.getRowCount()-1, "type", pType);
      td.setString(td.getRowCount()-1, "name", pName);
      td.setInt(td.getRowCount()-1, "age", pAge);
      saveTable(td, "plantTable.csv");
    }
  }

  //loads plant from table if possible
  void loadPlant() {
    for (int i = 0; i<td.getRowCount(); i++) {
      Plant p = new Plant(td.getString(i, "name"), td.getString(i, "type"), i, td.getInt(i, "age"));
      plants.add(p);
    }
  }

  void displayPlant() {
    if (state == 0) {
      for (int i = 0; i< plants.size(); i++) {
        Plant p = plants.get(i);
        p.display();
      }
    }
  }
  float bw = h/13.5;
  float bm = h/10.8;
  void checkHitbox(float mx, float my) {
    println(mx);
    println(my);
    if (dist(mx, my, w/22.5, h/12.5)<=bw) {
      state = 0;
      controller.progress(0);
    } else if (dist(mx, my, w/22.5, h/5)<=bw) {
      state = 1;
      controller.progress(0);
    } else if (dist(mx, my, w/22.5, h/3)<=bw) {
      state = 2;
      controller.progress(0);
    } else if (dist(mx, my, w/22.5, h/2.2)<=bw) {
      state = 3;
      controller.progress(0);
    } else if (dist(mx, my, w/22.5, h/1.1)<=bw) {
      controller.progress(2);
      state = 0;
    } else if ((dist(mx, my, w/5.15, h/1.73)<=bw || dist(mx, my, w/5.15+1*w/5.23, h/1.73)<=bw || dist(mx, my, w/5.15+2*w/5.23, h/1.73)<=bw)&& state == 1) {
      state = 4;
      controller.progress(0);
    } else if ((dist(mx, my, w/5.15+0*w/5.23, h/1.43)<=bw || dist(mx, my, w/5.15+1*w/5.23, h/1.43)<=bw || dist(mx, my, w/5.15+2*w/5.23, h/1.43)<=bw)&& state == 1) {
      state = 5;
      controller.progress(0);
    } else if (dist(mx, my, w/6.94, h/9.08)<=bw && (state == 4 ||state == 5||state == 6|| state == 7)) {
      state = 1;
      controller.progress(0);
    } else if (dist(mx, my, w/1.22, h/1.9)<=bm && state == 1) {
      state = 6;
    } else if (dist(mx, my, w/1.22, h/1.36)<=bm && state == 1) {
      state = 7;
    }if (state==3||state==2) {
      for (int i = 0; i<plants.size(); i++) {
        Plant p = plants.get(i);
        if (dist(mx, my, 1750*p.rScreen, 195*p.rScreen+p.tempGraphDist)<=20) {
          p.graphTime--;
        }
        if (dist(mx, my, 1750*p.rScreen, 275*p.rScreen+p.tempGraphDist)<=20) {
          p.graphTime++;
        }
      }
    }
  }

  void saveData(boolean d) {
    //updates the values for the plants every 5 minutes
    saveTime++;
    if (saveTime>300*60||d) {
      saveTime=0;
      for (int i=0; i<plants.size(); i++) {
        Plant p = plants.get(i);
        p.saveData();
        p.readData();
      }
    }
  }
  void readData() {
    //reads the data every 5 seconds
    readTime++;
    if (readTime>5*60) {
      readTime=0;
      for (int i=0; i<plants.size(); i++) {
        Plant p = plants.get(i);
        p.readData();
      }
    }
  }
}
