class Plant {

  int age;
  String name, scname;
  float humidityLevel=56;
  float lightLevel=50;
  float relativeLight;
  float relativeHumidity;
  String species;
  PImage baseplant, drop, sun;
  int plantNumber;
  float tempDist, eduDist, tempGraphDist;
  boolean badLight, badWater;
  PImage sadFace, mehFace, happyFace;
  int w = width;  //3840
  int h = height; //2160
  PImage graph;
  Table data;
  float[]lData;
  float[]hData;
  PImage eduButton, eduItem;
  PFont GivenName, RealName, StatusReport;
  float rScreen = w/1920.000;

  PImage plantImage;
  
  int showTime, graphTime, days;

  Plant(String giveName, String plantSpecies, int pn, int a) {
    age = a;
    name = giveName;
    species = plantSpecies;
    baseplant = loadImage("plantTemp.jpg");     //base for the plant info; basic lay-out
    drop = loadImage("water.jpg");
    sun = loadImage("sun.jpg");
    sadFace = loadImage("sad.png");            //faces to show how your plant is doing
    mehFace = loadImage("meh.png");
    happyFace = loadImage("happy.png");

    eduButton = loadImage("eduButtons.jpg");
    eduItem = loadImage("eduItem.jpg");
    println(plantSpecies);
    if (plantSpecies.equals("Garden Cress")) {
      println("Yay");
      plantImage = loadImage("1.png");
    } else if (plantSpecies.equals("Lettuce")) {
      plantImage = loadImage("2.png");
    } else if (plantSpecies.equals("Strawberry")) {
      plantImage = loadImage("3.png");
    } else if (plantSpecies.equals("Basil")) {
      plantImage = loadImage("4.png");
    } else if (plantSpecies.equals("Thyme")) {
      plantImage = loadImage("5.png");
    } else if (plantSpecies.equals("Money Plant")) {
      plantImage = loadImage("6.png");
    } else {
      plantImage = loadImage("sad.png");
    }


    GivenName = createFont("data/Sarabun-Light.ttf", h/30);
    RealName = createFont("data/Sarabun-Thin.ttf", h/50);
    StatusReport = createFont("data/Sarabun-Bold.ttf", h/43);
    plantNumber = pn;
    tempGraphDist = plantNumber*w/6.4;
    tempDist = w/10.7+plantNumber*w/4.8;           //distance from 0 for each plant menu (main): 1.158.88
    eduDist = w/8.9+plantNumber*w/5.25;            //distance from 0 for each plant menu (education)
    graph = loadImage("Graph.jpg");
    data = loadTable("plantData"+pn+".csv", "header");
    //checks to see if there is a table, if there is none, it will go to catch and make a new table
    try {
      println(data.getRowCount());
    }
    catch(Exception NullPointerException) {
      data = new Table();
      data.addColumn("humidityLevel");
      data.addColumn("lightLevel");
      saveTable(data, "plantData"+pn+".csv");
    }
    //gets data from table
    readData();
  }

  void display() {
    update();
    textAlign(CENTER);      // place all the text from the center
    imageMode(CORNER);
    image(baseplant, tempDist, h/27, w/5.3, h/1.1);       // mall for placing all the components 
    fill(255);
    rect(tempDist+w/300, h/22, w/5.5, h/1.15);          // square overlay to hide the mall picture
    fill(0);
    textFont(GivenName);
    textSize(height/21.6);
    text(name, tempDist+w/10.5, h/2.4);                 // plant name
    textSize(30);
    textFont(RealName);
    text(species, tempDist+w/10.5, h/2.2);        // scientific plant name
    text(menu.td.getInt(plantNumber,"age")+" days old", tempDist+w/10.5, h/2.1);
    imageMode(CENTER);
    image(sun, tempDist+w/26.2, h/1.91, h/19.46, h/19.46);                        // sun image 
  image(drop, tempDist+w/26.2, h/1.299, h/26.7, h/22);                       // drop image
    fill(242);
    //circle(tempDist+w/10.7, h/4.7, h/4.4);                        // plant pic circle placeholder
    image(plantImage, tempDist+w/10.7, h/4.7);
    circle(tempDist+w/10.5, h/1.665, h/6.12);                        // sun circle
    circle(tempDist+w/10.5, h/1.2125, h/6.12);                        // water circle
    fill(255, 225, 0);
    arc(tempDist+w/10.5, h/1.665, h/6.12, h/6.12, -0.5*PI, relativeLight*(2*PI)-0.5*PI);   // light level arc
    fill(75, 220, 255);
    arc(tempDist+w/10.5, h/1.2125, h/6.12, h/6.12, -0.5*PI, relativeHumidity*(2*PI)-0.5*PI);  // water level arc
    stroke(0, 255, 0);
    strokeWeight(5);
    line(tempDist+w/10.5, h/1.665, tempDist+w/10.5, h/1.47);               // green indication line - perfect light level
    line(tempDist+w/10.5, h/1.2125, tempDist+w/10.5, h/1.105);               // " - perfect water level
    noStroke();
    fill(255);
    circle(tempDist+w/10.5, h/1.665, h/9);                           // middle circle overlay light level
    circle(tempDist+w/10.5, h/1.2125, h/9);                           // middle circle overlay light level
    fill(255, 225, 0);
    textFont(StatusReport);
    if (relativeLight>0.66) {
      text("Less Sun", tempDist+w/10.5, h/1.665);
      badLight = true;
    } else if (relativeLight>0.33) {
      text("Just Right", tempDist+w/10.5, h/1.665);
      badLight = false;
    } else {
      text("More Sun", tempDist+w/10.5, h/1.665);
      badLight = true;
    }
    fill(75, 220, 255);
    if (relativeHumidity>0.66) {
      text("Less Water", tempDist+w/10.5, h/1.2125);
      badWater = true;
    } else if (relativeHumidity>0.33) {
      text("Just Right", tempDist+w/10.5, h/1.2125);
      badWater= false;
    } else {
      text("More Water", tempDist+w/10.5, h/1.2125);
      badWater = true;
    }
    if (badWater && badLight) {
      image(sadFace, 500+tempDist, h/3.3, h/16.36, h/16.36);
    } else if (badWater||badLight) {
      image(mehFace, 500+tempDist, h/3.3, h/16.36, h/16.36);
    } else {
      image(happyFace, tempDist+w/7.08, h/3.3, h/16.36, h/16.36);
    }
    println(potOne.analogRead(0));
  }

  void show() {
    imageMode(CORNER);
    image(eduItem, eduDist, h/6.35, w/6.095, h/1.33);
    imageMode(CENTER);
    rectMode(CENTER);
    fill(255);
    rect(eduDist+w/12.19, h/1.55, w/7.67, h/2);
    image(eduButton, eduDist+w/12.19, h/1.5, w/12.8, w/5.98);
    textAlign(CENTER);
    textFont(GivenName);
    fill(0);
    text(name, eduDist+w/12.19, h/2.15);                 // plant name
    image(plantImage, eduDist+w/12.19, h/3.35);
  }

  void update() {
    humidityLevel = potOne.analogRead(0);
    lightLevel = potOne.analogRead(1);
    humidityLevel = map(humidityLevel, 0, 1023, 100, 0);
    lightLevel = map(lightLevel, 0, 1023, 100, 0);
    relativeLight= lightLevel/100;
    relativeHumidity = humidityLevel/100;
    delay(500);
  }
  
  void updateTime(){
    if (hour()+days-graphTime<0) {
      days+=24;
    } else if (hour()+days-graphTime>23) {
      days-=24;
    }
    showTime = hour()+days-graphTime;
    if (graphTime<0) {
      graphTime=0;
    }
  }

  float sGraph = 460*rScreen;       //start
  float eGraph = 1700*rScreen;      //end

  void showSunGraph() {
    //shows template for graphs
    image(graph, 180*rScreen, 100*rScreen+tempGraphDist, 1650*rScreen, 270*rScreen);
    //makes the template blank
    fill(255);
    rect(200*rScreen, 110*rScreen+tempGraphDist, 1600*rScreen, 240*rScreen);
    fill(240);
    //plant info
    imageMode(CENTER);
    image(plantImage, 290*rScreen, 195*rScreen+tempGraphDist, 130*rScreen, 130*rScreen);
    imageMode(CORNER);
    textFont(GivenName);
    textAlign(CENTER, CENTER);
    fill(0);
    text(name, 290*rScreen, 300*rScreen+tempGraphDist);
    strokeWeight(2*rScreen);
    stroke(110, 255, 110);
    //green line in graph
    line(sGraph-10*rScreen, 230*rScreen+tempGraphDist, eGraph, 230*rScreen+tempGraphDist);
    //grey line in graph
    stroke(200);
    fill(200);
    if (minute()>9) {
      text(showTime+":"+minute(), 1750*rScreen, 230*rScreen+tempGraphDist);
    } else {
      text(showTime+":0"+minute(), 1750*rScreen, 230*rScreen+tempGraphDist);
    }
    triangle(1750*rScreen, 180*rScreen+tempGraphDist, 1780*rScreen, 210*rScreen+tempGraphDist, 1720*rScreen, 210*rScreen+tempGraphDist);
    triangle(1750*rScreen, 290*rScreen+tempGraphDist, 1780*rScreen, 260*rScreen+tempGraphDist, 1720*rScreen, 260*rScreen+tempGraphDist);
    text(50, sGraph-40*rScreen, 225*rScreen+tempGraphDist);
    text(100, sGraph-40*rScreen, 130*rScreen+tempGraphDist);
    line(sGraph-10*rScreen, 136*rScreen+tempGraphDist, eGraph, 136*rScreen+tempGraphDist);
    text(75, sGraph-40*rScreen, 177*rScreen+tempGraphDist);
    line(sGraph-10*rScreen, 183*rScreen+tempGraphDist, eGraph, 183*rScreen+tempGraphDist);
    text(25,sGraph-40*rScreen, 270*rScreen+tempGraphDist);
    line(sGraph-10*rScreen, 277*rScreen+tempGraphDist, eGraph, 277*rScreen+tempGraphDist);
    text(0, sGraph-40*rScreen, 317*rScreen+tempGraphDist);
    strokeWeight(18*rScreen);
    stroke(255,190,49, 255);
    //shows data of humidity in the graph
    if ((graphTime+1)*40>= lData.length) {
      if ((graphTime+1)*40<= lData.length+(lData.length % 40)) {
        for (int i=0; i<(lData.length%40); i++) {
          line(sGraph+31.5*(i+(40-lData.length%40))*rScreen, 320*rScreen+tempGraphDist, sGraph+31.5*(i+(40-lData.length%40))*rScreen, 320*rScreen-lData[lData.length-(lData.length%40)+i]*1.8*rScreen+tempGraphDist);
        }
      }
    } else {

      if (hData.length<=40) {
        for (int i=0; i<lData.length; i++) {
          line(sGraph*rScreen+12*i, 320*rScreen+tempGraphDist, sGraph+12*i*rScreen, 320*rScreen-lData[i]*1.8*rScreen+tempGraphDist);
        }
      } else {
        for (int i=0; i<40; i++) {
          line(sGraph+31.5*i*rScreen, 320*rScreen+tempGraphDist, sGraph+31.5*i*rScreen, 320*rScreen-lData[lData.length-(40*(1+graphTime))+i]*1.8*rScreen+tempGraphDist);
        }
      }
    }
    fill(255);
    noStroke();
    rect(sGraph-10*rScreen, 324*rScreen+tempGraphDist, 1250*rScreen, 10);
    stroke(200);
    strokeWeight(2*rScreen);
    line(sGraph-10*rScreen, 324*rScreen+tempGraphDist, eGraph, 324*rScreen+tempGraphDist);
    //black lines in graph
    strokeWeight(3);
    noStroke();
  }
  void showWaterGraph() {
    //shows template for graphs
    image(graph, 180*rScreen, 100*rScreen+tempGraphDist, 1650*rScreen, 270*rScreen);
    //makes the template blank
    fill(255);
    rect(200*rScreen, 110*rScreen+tempGraphDist, 1600*rScreen, 240*rScreen);
    fill(240);
    //plant info
    imageMode(CENTER);
    image(plantImage, 290*rScreen, 195*rScreen+tempGraphDist, 130*rScreen, 130*rScreen);
    imageMode(CORNER);
    textFont(GivenName);
    textAlign(CENTER, CENTER);
    fill(0);
    text(name, 290*rScreen, 300*rScreen+tempGraphDist);
    strokeWeight(2*rScreen);
    stroke(110, 255, 110);
    //green line in graph
    line(sGraph-10*rScreen, 230*rScreen+tempGraphDist, eGraph, 230*rScreen+tempGraphDist);
    //grey line in graph
    stroke(200);
    fill(200);
    if (minute()>9) {
      text(showTime+":"+minute(), 1750*rScreen, 230*rScreen+tempGraphDist);
    } else {
      text(showTime+":0"+minute(), 1750*rScreen, 230*rScreen+tempGraphDist);
    }
    triangle(1750*rScreen, 180*rScreen+tempGraphDist, 1780*rScreen, 210*rScreen+tempGraphDist, 1720*rScreen, 210*rScreen+tempGraphDist);
    triangle(1750*rScreen, 290*rScreen+tempGraphDist, 1780*rScreen, 260*rScreen+tempGraphDist, 1720*rScreen, 260*rScreen+tempGraphDist);
    text(50, sGraph-40*rScreen, 225*rScreen+tempGraphDist);
    text(100, sGraph-40*rScreen, 130*rScreen+tempGraphDist);
    line(sGraph-10*rScreen, 136*rScreen+tempGraphDist, eGraph, 136*rScreen+tempGraphDist);
    text(75, sGraph-40*rScreen, 177*rScreen+tempGraphDist);
    line(sGraph-10*rScreen, 183*rScreen+tempGraphDist, eGraph, 183*rScreen+tempGraphDist);
    text(25,sGraph-40*rScreen, 270*rScreen+tempGraphDist);
    line(sGraph-10*rScreen, 277*rScreen+tempGraphDist, eGraph, 277*rScreen+tempGraphDist);
    text(0, sGraph-40*rScreen, 317*rScreen+tempGraphDist);
    strokeWeight(18*rScreen);
    stroke(0, 197, 255, 255);
    //shows data of humidity in the graph
    if ((graphTime+1)*40>= hData.length) {
      if ((graphTime+1)*40<= hData.length+(hData.length % 40)) {
        for (int i=0; i<(hData.length%40); i++) {
          line(sGraph+31.5*(i+(40-hData.length%40))*rScreen, 320*rScreen+tempGraphDist, sGraph+31.5*(i+(40-hData.length%40))*rScreen, 320*rScreen-hData[hData.length-(hData.length%40)+i]*1.8*rScreen+tempGraphDist);
        }
      }
    } else {

      if (hData.length<=40) {
        for (int i=0; i<hData.length; i++) {
          line(sGraph*rScreen+12*i, 320*rScreen+tempGraphDist, sGraph+12*i*rScreen, 320*rScreen-hData[i]*1.8*rScreen+tempGraphDist);
        }
      } else {
        for (int i=0; i<40; i++) {
          line(sGraph+31.5*i*rScreen, 320*rScreen+tempGraphDist, sGraph+31.5*i*rScreen, 320*rScreen-hData[hData.length-(40*(1+graphTime))+i]*1.8*rScreen+tempGraphDist);
        }
      }
    }
    fill(255);
    noStroke();
    rect(sGraph-10*rScreen, 324*rScreen+tempGraphDist, 1250*rScreen, 10);
    stroke(200);
    strokeWeight(2*rScreen);
    line(sGraph-10*rScreen, 324*rScreen+tempGraphDist, eGraph, 324*rScreen+tempGraphDist);
    //black lines in graph
    strokeWeight(3);
    noStroke();
  }
  

  void saveData() {
    //makes new row for the current levels
    data.addRow();
    //imports the numbers in the correct column
    data.setFloat(data.getRowCount()-1, "humidityLevel", humidityLevel);
    data.setFloat(data.getRowCount()-1, "lightLevel", lightLevel);
    //saves the table
    saveTable(data, "plantData"+plantNumber+".csv");
  }
  void readData() {
    //assigns the data in the table to variables in the program
    float[] liData = new float[data.getRowCount()];
    float[] huData = new float[data.getRowCount()];
    for (int i=0; i<data.getRowCount(); i++) {
      liData[i] = data.getFloat(i, "lightLevel");
      huData[i] = data.getFloat(i, "humidityLevel");
    }
    lData = liData;
    hData = huData;
  }
}
